import { Type } from '@angular/core';
import { EventBus } from '@bimeister/event-bus/rxjs';
import { Observable, Subscription } from 'rxjs';
import { TreeEvents } from '../events/tree.events';
import { FlatTreeItem } from './flat-tree-item.class';
import { TreeDataDisplayCollection } from './tree-data-display-collection.class';
export declare class DefaultTreeEventHandler {
    protected readonly eventBus: EventBus;
    protected readonly dataDisplayCollection: TreeDataDisplayCollection;
    protected subscription: Subscription;
    constructor(eventBus: EventBus, dataDisplayCollection: TreeDataDisplayCollection);
    protected subscribeToEvents(): void;
    protected getSubscriptionToSetData(): Subscription;
    protected getSubscriptionForScrollTo(): Subscription;
    protected getSubscriptionForRemoveItem(): Subscription;
    protected getSubscriptionForUpdateItem(): Subscription;
    protected updateItem(updatedItem: FlatTreeItem, data: FlatTreeItem[]): void;
    protected removeItem(removeItemId: string, data: FlatTreeItem[]): void;
    reconnect(): void;
    disconnect(): void;
    getEvents<E extends TreeEvents.TreeEventBase>(eventType: Type<E>): Observable<E>;
    private getSubscriptionForSetChildren;
    private getSubscriptionForRemoveChildren;
    private setChildren;
    private removeItemWithChildren;
    private removeChildren;
    private getRemovedChildren;
    protected static treeItemExists(treeItemId: string, data: FlatTreeItem[]): boolean;
    protected static getTreeItem(treeItemId: string, data: FlatTreeItem[]): FlatTreeItem;
}
