import { TrackByFunction } from '@angular/core';
import { BehaviorSubject, Observable, Subject } from 'rxjs';
import { TreeDataDisplayCollectionRef } from '../interfaces/tree-data-display-collection-ref.interface';
import { FlatTreeItem } from './flat-tree-item.class';
export declare class TreeDataDisplayCollection implements TreeDataDisplayCollectionRef {
    readonly data$: BehaviorSubject<FlatTreeItem[]>;
    readonly selectedIdsList$: BehaviorSubject<string[]>;
    readonly trackBy$: Subject<TrackByFunction<FlatTreeItem>>;
    readonly scrollBehavior$: BehaviorSubject<ScrollBehavior>;
    readonly expandedIdsList$: BehaviorSubject<string[]>;
    readonly hasDragAndDrop$: BehaviorSubject<boolean>;
    readonly treeItemSizePx$: BehaviorSubject<number>;
    readonly isLoading$: BehaviorSubject<boolean>;
    setExpandedIdsList(value: string[]): void;
    setIsLoading(value: boolean): void;
    setData(data: FlatTreeItem[]): Observable<FlatTreeItem[]>;
    setSelectedIdsList(value: string[]): void;
    static readonly trackBy: TrackByFunction<any>;
}
