import { BusEventBase } from '@bimeister/pupakit.common';
import { Nullable } from '@bimeister/utilities';
import { FlatTreeItem } from '../classes/flat-tree-item.class';
import { DropEventInterface } from '../interfaces/drop-event.interface';
interface SetChildrenEventPayload {
    treeItemId: Nullable<string>;
    children: FlatTreeItem[];
}
export declare namespace TreeEvents {
    class TreeEventBase<T = unknown> extends BusEventBase<T> {
        readonly payload: T;
        readonly fromId: Nullable<string>;
        readonly scope: Nullable<string>;
        readonly id: string;
        readonly type: Nullable<string>;
        constructor(payload?: T, fromId?: Nullable<string>);
    }
    class Click extends TreeEventBase<FlatTreeItem> {
    }
    class RemoveItem extends TreeEventBase<string> {
    }
    class UpdateItem extends TreeEventBase<FlatTreeItem> {
    }
    class ScrollById extends TreeEventBase<string> {
    }
    class Drop extends TreeEventBase<DropEventInterface<FlatTreeItem>> {
    }
    class ScrollByIndex extends TreeEventBase<number> {
    }
    class ScrollViewport extends TreeEventBase<number> {
    }
    class SetData extends TreeEventBase<FlatTreeItem[]> {
    }
    class SetLoading extends TreeEventBase<boolean> {
    }
    class SetSelected extends TreeEventBase<string[]> {
    }
    class Collapse extends TreeEventBase<string> {
    }
    class Expand extends TreeEventBase<string> {
    }
    class ExpandWhileDragging extends TreeEventBase<string> {
    }
    class RemoveChildren extends TreeEventBase<string> {
    }
    class SetExpanded extends TreeEventBase<string[]> {
    }
    class SetChildren extends TreeEventBase<SetChildrenEventPayload> {
    }
}
export {};
